﻿<AML>
 <Item type="Method" id="3FC47D16AA5E4EB3981DD963B7566385" action="add">
  <comments>Journal Register by Chan</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_journal_register_report
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                Getting Required Information for Report

            Hooks:
                Called by:	acc_journal_register_report_call

            Inputs:
                acc_from_date,
                acc_to_date,
                erp_company,
                acc_vch_type,
                acc_report_currency,
                erp_com_name

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_journal_register_report";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var acc_from_date = this.getProperty("acc_from_date", "");
                var acc_to_date = this.getProperty("acc_to_date", "");
                var erp_company = this.getProperty("erp_company", "");
                var acc_vch_type = this.getProperty("acc_vch_type", "");
                var acc_report_currency = this.getProperty("acc_report_currency", "");
                var erp_com_name = this.getProperty("erp_com_name", "");
                string date_condition = "";
                var qurey = "";
                date_condition = "  and ( Convert(Date,innovator.ConvertToLocal(acc_journal_header.acc_date,DEFAULT),111) Between Convert(Date,'" + acc_from_date + "',111) "
                    + " and  Convert(Date,'" + acc_to_date + "',111))";

                string date_condition_journal = " where (Convert(Date,innovator.ConvertToLocal(acc_date,DEFAULT),111) Between Convert(Date,'" + acc_from_date + "',111) "
                    + " and  Convert(Date,'" + acc_to_date + "',111))";

                var clear_report_data = myInnovator.applySQL("DELETE FROM innovator.acc_journal_register");
                string queryjournal = "select * from innovator.ACC_JOURNAL_REGISTER";
                if (acc_vch_type == "JournalRegister")
                {
                    qurey = "select receivablepayabletype,journaltype,classification,acc_journal_no,acc_date,pop_invoice_remarks,acc_account,pop_invoice_date,pop_invoice_no,name,pop_total_amount,sop_due_date,sop_payment_term,pop_sub_amount,pop_gst_amount,pop_sg_total_amount,pop_sg_sub_amount,pop_sg_gst_amount,pop_currency_rate,acc_currencycode,acc_accountdetail_name,acc_tax_type from (select 'Trade Payables - Accrued Purchases' as receivablepayabletype,'Purchase' as journaltype,NULL as classification,acc_journal_no,acc_date,pop_invoice_remarks,pop_purchase_invoice.acc_account,pop_purchase_invoice.pop_invoice_date,pop_invoice_no,Vendor.name,sum(pop_purchase_invoice.pop_total_amount) as pop_total_amount,NULL as sop_due_date,NULL as sop_payment_term,pop_purchase_invoice.pop_sub_amount,pop_purchase_invoice.pop_gst_amount,pop_purchase_invoice.pop_sg_total_amount,pop_purchase_invoice.pop_sg_sub_amount,pop_purchase_invoice.pop_sg_gst_amount,pop_purchase_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,pop_purchase_invoice.acc_tax_type from innovator.acc_journal_header inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.ACC_CURRENCY on ACC_CURRENCY.id=pop_purchase_invoice.pop_currency  inner join innovator.Vendor on Vendor.id=pop_purchase_invoice.pop_vendor inner join innovator.acc_AccountDetails on acc_AccountDetails.id=pop_purchase_invoice.acc_account where acc_journal_header.acc_transactiontype='Purchase' group by pop_invoice_no,acc_date,pop_invoice_remarks,acc_journal_no,pop_purchase_invoice.acc_account,pop_purchase_invoice.pop_invoice_date,pop_invoice_no,Vendor.name,pop_purchase_invoice.pop_sub_amount,pop_purchase_invoice.pop_gst_amount,pop_purchase_invoice.pop_sg_total_amount,pop_purchase_invoice.pop_sg_sub_amount,pop_purchase_invoice.pop_sg_gst_amount,pop_purchase_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,pop_purchase_invoice.acc_tax_type Union all select 'Trade Receivables - Accrued Revenue' as receivablepayabletype,'Sale' as journaltype,sop_sale_invoice.classification,acc_journal_no,acc_journal_header.acc_date,sop_invoice_remarks,sop_sale_invoice.acc_account,sop_sale_invoice.sop_invoice_date,sop_sale_invoice.sop_invoice_no,CUSTOMER.name,sum(sop_sale_invoice.pop_total_amount) as pop_total_amount,sop_sale_invoice.sop_due_date,sop_sale_invoice.sop_payment_term,sop_sale_invoice.pop_sub_amount,sop_sale_invoice.pop_gst_amount,sop_sale_invoice.pop_sg_total_amount,sop_sale_invoice.pop_sg_sub_amount,sop_sale_invoice.pop_sg_gst_amount,sop_sale_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,sop_sale_invoice.acc_tax_type from innovator.acc_journal_header inner join innovator.sop_sale_invoice on sop_sale_invoice.id=acc_journal_header.acc_sop_voucher_reference inner join innovator.CUSTOMER on CUSTOMER.id=sop_sale_invoice.sop_customer inner join innovator.ACC_CURRENCY on ACC_CURRENCY.id=sop_sale_invoice.pop_currency inner join innovator.acc_AccountDetails on acc_AccountDetails.id=sop_sale_invoice.acc_account where acc_journal_header.acc_transactiontype='Sale' group by sop_invoice_no,acc_journal_header.acc_date,sop_invoice_remarks,acc_journal_no,sop_sale_invoice.acc_account,sop_sale_invoice.sop_invoice_date,CUSTOMER.name,sop_sale_invoice.pop_sub_amount,sop_sale_invoice.pop_gst_amount,sop_sale_invoice.pop_sg_total_amount,sop_sale_invoice.pop_sg_sub_amount,sop_sale_invoice.pop_sg_gst_amount,sop_sale_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,sop_sale_invoice.acc_tax_type,sop_sale_invoice.classification,sop_due_date,SOP_PAYMENT_TERM union all select 'Income Claims Receivable' as receivablepayabletype,'Income' as journaltype,NULL as classification,acc_journal_no,acc_date,acc_memo,acc_income_expense_detail.acc_account_no,acc_income_expense_header.acc_payment_date,acc_invoice_number,Customer.name,sum(acc_income_expense_detail.acc_amount) as pop_total_amount,NULL as sop_due_date,NULL as sop_payment_term,NULL as pop_sub_amount,NULL as pop_gst_amount,NULL as pop_sg_total_amount,NULL as pop_sg_sub_amount,NULL as pop_sg_gst_amount,acc_income_expense_header.acc_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,NULL as acc_tax_type from innovator.acc_journal_header inner join innovator.acc_income_expense_header on acc_income_expense_header.acc_reference_no=acc_journal_header.ACC_REFNO inner join innovator.ACC_CURRENCY on ACC_CURRENCY.id=acc_income_expense_header.acc_currency left join innovator.Customer on Customer.id=acc_income_expense_header.ACC_SUPPLIER_NAME inner join innovator.acc_income_expense_detail on acc_income_expense_detail.source_id=acc_income_expense_header.id inner join innovator.acc_AccountDetails on acc_AccountDetails.id=acc_income_expense_detail.acc_account_no where acc_journal_header.acc_transactiontype='Income' group by acc_invoice_number,acc_date,acc_memo,acc_journal_no,acc_income_expense_detail.acc_account_no,acc_income_expense_header.acc_payment_date,acc_invoice_number,Customer.name,acc_income_expense_header.acc_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name union all select 'Expense Claims Payable' as receivablepayabletype,'Expense' as journaltype,NULL as classification,acc_journal_no,acc_date,acc_memo,acc_income_expense_detail.acc_account_no,acc_income_expense_header.acc_payment_date,acc_invoice_number,Customer.name,sum(acc_income_expense_detail.acc_amount) as pop_total_amount,NULL as sop_due_date,NULL as sop_payment_term,NULL as pop_sub_amount,NULL as pop_gst_amount,NULL as pop_sg_total_amount,NULL as pop_sg_sub_amount,NULL as pop_sg_gst_amount,acc_income_expense_header.acc_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,NULL as acc_tax_type from innovator.acc_journal_header inner join innovator.acc_income_expense_header on acc_income_expense_header.acc_reference_no=acc_journal_header.ACC_REFNO inner join innovator.ACC_CURRENCY on ACC_CURRENCY.id=acc_income_expense_header.acc_currency left join innovator.Customer on Customer.id=acc_income_expense_header.ACC_SUPPLIER_NAME inner join innovator.acc_income_expense_detail on acc_income_expense_detail.source_id=acc_income_expense_header.id inner join innovator.acc_AccountDetails on acc_AccountDetails.id=acc_income_expense_detail.acc_account_no where acc_journal_header.acc_transactiontype='Expense' group by acc_invoice_number,acc_date,acc_memo,acc_journal_no,acc_income_expense_detail.acc_account_no,acc_income_expense_header.acc_payment_date,acc_invoice_number,Customer.name,acc_income_expense_header.acc_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name) as result" + date_condition_journal + "  order by name,Convert(Date,acc_date,111) ,pop_invoice_no ASC";
                    Item _get_data = myInnovator.applySQL(qurey);

                    var _get_data_count = _get_data.getItemCount();

                    if (_get_data_count > 0)
                    {
                        for (int i = 0; i < _get_data_count; i++)
                        {
                            var j = i + 1;
                            var _get_data_result = _get_data.getItemByIndex(i);
                            var acc_date = _get_data_result.getProperty("acc_date");
                            DateTime dt_acc_date = DateTime.Parse(acc_date);
                            dt_acc_date = new DateTimeOffset(dt_acc_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                            var get_last_date = dt_acc_date.ToString("yyyy-MM-ddTHH:mm:ss");
                            var acc_currency_id = "374D7C8DC875411A9A3BD0FC5A8BC066";

                            var query = "select acc_currency.id,acc_currency.ACC_OPERATOR,acc_currencycode,acc_currency_detail.acc_monthly_rate,acc_currency_detail.acc_date" + " from innovator.acc_currency inner join innovator.acc_currency_detail" + " on  acc_currency.id=acc_currency_detail.source_id " + " where acc_currency.id='" + acc_currency_id + "' " + " and DATEPART(m, acc_currency_detail.acc_date) = DATEPART(m, DATEADD(m, -1, '" + get_last_date + "')) AND DATEPART(yyyy, acc_currency_detail.acc_date) = DATEPART(yyyy, DATEADD(m, -1, '" + get_last_date + "'))";
                            Item result_data = myInnovator.applySQL(query);
                            var lastMonthRate = result_data.getProperty("acc_monthly_rate", "");


                            var local_acc_date = dt_acc_date.ToString("yyyy-MM-dd");
                            var acc_accountdetail_name = _get_data_result.getProperty("acc_accountdetail_name");
                            var acc_refno = _get_data_result.getProperty("pop_invoice_no");
                            var pop_total_amount = _get_data_result.getProperty("pop_total_amount");
                            var pop_currency_rate = _get_data_result.getProperty("pop_currency_rate");
                            var acc_currencycode = _get_data_result.getProperty("acc_currencycode");
                            var pop_sub_amount = _get_data_result.getProperty("pop_sub_amount");
                            var pop_gst_amount = _get_data_result.getProperty("pop_gst_amount");
                            var pop_sg_total_amount = _get_data_result.getProperty("pop_sg_total_amount");
                            var pop_sg_sub_amount = _get_data_result.getProperty("pop_sg_sub_amount");
                            var pop_sg_gst_amount = _get_data_result.getProperty("pop_sg_gst_amount");
                            var acc_tax_type = _get_data_result.getProperty("acc_tax_type");
                            var acc_sg_credit = _get_data_result.getProperty("acc_sg_credit");
                            var acc_sg_debit = _get_data_result.getProperty("acc_sg_debit");
                            var pop_invoice_remarks = _get_data_result.getProperty("pop_invoice_remarks");
                            var name = _get_data_result.getProperty("name");
                            var acc_department_so_name = _get_data_result.getProperty("acc_department_so_name");
                            var acc_journal_no = _get_data_result.getProperty("acc_journal_no");
                            var journaltype = _get_data_result.getProperty("journaltype");
                            var receivablepayabletype = _get_data_result.getProperty("receivablepayabletype");
                            var classification = _get_data_result.getProperty("classification");

                            Item acc_journal_register = myInnovator.newItem("acc_journal_register", "add");
                            acc_journal_register.setProperty("acc_journal_classification", classification);
                            acc_journal_register.setProperty("acc_currencycode", acc_currencycode);
                            acc_journal_register.setProperty("acc_rate", pop_currency_rate);
                            acc_journal_register.setProperty("acc_journaltype", journaltype);
                            acc_journal_register.setProperty("acc_receivablepayabletype", receivablepayabletype);
                            acc_journal_register.setProperty("acc_journalregister_date", local_acc_date);
                            acc_journal_register.setProperty("acc_accountdetail_name", acc_accountdetail_name);
                            acc_journal_register.setProperty("acc_amount_currency", pop_total_amount);
                            acc_journal_register.setProperty("acc_department_so_name", acc_department_so_name);
                            acc_journal_register.setProperty("erp_company", erp_company);
                            acc_journal_register.setProperty("erp_com_name", erp_com_name);
                            acc_journal_register.setProperty("acc_refno", acc_refno);
                            acc_journal_register.setProperty("acc_sg_credit", acc_sg_credit);
                            acc_journal_register.setProperty("acc_sg_debit", acc_sg_debit);
                            acc_journal_register.setProperty("acc_from_date", acc_from_date);
                            acc_journal_register.setProperty("acc_to_date", acc_to_date);
                            acc_journal_register.setProperty("acc_journal_no", acc_journal_no);
                            acc_journal_register.setProperty("pop_vendor_name", name);
                            acc_journal_register.setProperty("pop_invoice_remarks", pop_invoice_remarks);
                            acc_journal_register.setProperty("acc_vch_type", "Journal");
                            acc_journal_register.setProperty("acc_report_currency_filter", acc_report_currency);
                            acc_journal_register.setProperty("acc_lastmonthrate", lastMonthRate);
                            acc_journal_register = acc_journal_register.apply();
                            int icount = acc_journal_register.getItemCount();
                            if (acc_journal_register.isError())
                            {
                                return myInnovator.newError("Error While Adding Journal Register report.");
                            }

                        }
                    }



                    /* Start Greater Than One allocation*/

                    string queryallocation = "select acc_amount,acc_department_so_no,pop_invoice_no,acc_department_so_name,acc_accountdetail_name,acc_currencycode  from (select sum(pop_purchase_allocation.acc_amount) as acc_amount,acc_department_so_no,pop_invoice_no,acc_department_so_name,acc_accountdetail_name,acc_currencycode from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id  join innovator.acc_AccountDetails on acc_AccountDetails.acc_accountdetail_code=pop_purchase_allocation.acc_gl_code_number inner join innovator.acc_currency on acc_currency.id=POP_PURCHASE_INVOICE.POP_CURRENCY group by acc_department_so_no,pop_invoice_no,acc_department_so_name,acc_accountdetail_name,acc_currencycode union all select sum(sop_sale_allocation.acc_amount) as acc_amount,acc_department_so_no,sop_invoice_no,acc_department_so_name,acc_accountdetail_name,acc_currencycode from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id inner join innovator.acc_AccountDetails on acc_AccountDetails.acc_accountdetail_code=sop_sale_allocation.acc_gl_code_number inner join innovator.acc_currency on acc_currency.id=sop_sale_invoice.POP_CURRENCY group  by acc_department_so_no,sop_invoice_no,acc_department_so_name, acc_accountdetail_name,acc_currencycode union all select sum(acc_income_expense_allocation.acc_amount) as acc_amount,acc_department_so_no,acc_invoice_number,acc_department_so_name,acc_accountdetail_name,acc_currencycode from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id inner join innovator.acc_AccountDetails on acc_AccountDetails.acc_accountdetail_code=acc_income_expense_allocation.acc_gl_code_number inner join innovator.acc_currency on acc_currency.id=acc_income_expense_header.ACC_CURRENCY group by acc_department_so_no,acc_invoice_number,acc_department_so_name,acc_accountdetail_name,acc_currencycode ) as Allocation";

                    Item _get_allocation_data = myInnovator.applySQL(queryallocation);

                    var _get_allocation_data_count = _get_allocation_data.getItemCount();

                    if (_get_allocation_data_count > 0)
                    {
                        for (int l = 0; l < _get_allocation_data_count; l++)
                        {
                            var __get_allocation_data_result = _get_allocation_data.getItemByIndex(l);
                            var pop_invoice_no_allocation = __get_allocation_data_result.getProperty("pop_invoice_no");
                            var acc_department_so_no_allocation = __get_allocation_data_result.getProperty("acc_department_so_no");
                            var acc_department_so_no = __get_allocation_data_result.getProperty("acc_department_so_no");
                            var acc_department_so_name = __get_allocation_data_result.getProperty("acc_department_so_name");
                            var acc_accountdetail_name = __get_allocation_data_result.getProperty("acc_accountdetail_name");
                            var acc_currencycode = __get_allocation_data_result.getProperty("acc_currencycode");
                            if (acc_department_so_no_allocation == "D10")
                            {

                                string allocation = "update innovator.acc_journal_register set ACC_D10=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'";
                                myInnovator.applySQL(allocation);

                            }
                            else if (acc_department_so_no_allocation == "D15")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D15=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount ) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }
                            else if (acc_department_so_no_allocation == "D20")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D20=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }
                            else if (acc_department_so_no_allocation == "D28")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D28=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }
                            else if (acc_department_so_no_allocation == "D30")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D30=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }
                            else if (acc_department_so_no_allocation == "D35")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D35=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }
                            else if (acc_department_so_no_allocation == "D40")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D40=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate ) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }
                            else if (acc_department_so_no_allocation == "D25")
                            {
                                myInnovator.applySQL("update innovator.acc_journal_register set ACC_D25=(select sum(acc_amount) from (select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(sop_sale_allocation.acc_amount * pop_currency_rate) acc_amount from innovator.sop_sale_invoice inner join innovator.sop_sale_allocation on sop_sale_allocation.source_id= sop_sale_invoice.id where sop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "' union all select sum(acc_income_expense_allocation.acc_amount * acc_rate) acc_amount from innovator.acc_income_expense_header inner join innovator.acc_income_expense_allocation on acc_income_expense_allocation.source_id= acc_income_expense_header.id where acc_invoice_number='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no + "') as Amount),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'");
                            }

                        }
                    }
                    /* End Greater Than One allocation*/


                    /*Start Invoice Divided By Count*/



                    Item _get_journal_data = myInnovator.applySQL(queryjournal);

                    var _get_journal_data_count = _get_journal_data.getItemCount();

                    if (_get_journal_data_count > 0)
                    {
                        for (int m = 0; m < _get_journal_data_count; m++)
                        {
                            var _get_journal_data_result = _get_journal_data.getItemByIndex(m);
                            var acc_refno_journal = _get_journal_data_result.getProperty("acc_refno");
                            string journal_divide = "update innovator.acc_journal_register set ACC_AMOUNT_CURRENCY=ACC_AMOUNT_CURRENCY/(select case when SUM(number)=0 then 1 end as number from (select Count(pop_purchase_allocation.id) as number from innovator.pop_purchase_allocation inner join innovator.POP_PURCHASE_INVOICE on POP_PURCHASE_INVOICE.id=pop_purchase_allocation.SOURCE_ID where pop_invoice_no='" + acc_refno_journal + "' union all select Count(sop_sale_allocation.id) as number from innovator.sop_sale_allocation inner join innovator.sop_sale_invoice on sop_sale_invoice.id=sop_sale_allocation.SOURCE_ID where sop_invoice_no='" + acc_refno_journal + "' union all select Count(acc_income_expense_allocation.id) as number from innovator.acc_income_expense_allocation inner join innovator.acc_income_expense_header on acc_income_expense_header.id=acc_income_expense_allocation.SOURCE_ID where acc_invoice_number='" + acc_refno_journal + "') as Number) where acc_refno='" + acc_refno_journal + "'";
                            myInnovator.applySQL(journal_divide);
                        }
                    }

                    /*End Invoice Divided By Count*/


                    /*Start Transcation Amount*/

                    string transcation_amountquery = "select acc_sg_credit,acc_credit,acc_amount_currency,pop_invoice_no,acc_accountdetail_name from ( select acc_sg_credit,acc_credit,acc_amount_currency,pop_invoice_no,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=pop_purchase_invoice.acc_account where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='Account Payable' union all select acc_sg_debit,acc_debit,acc_amount_currency,sop_invoice_no,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id  inner join innovator.sop_sale_invoice on sop_sale_invoice.sop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=sop_sale_invoice.acc_account where acc_journal_header.acc_transactiontype='Sale' and acc_journal_details.acc_systemaccountid='Account Receivable' union all select acc_sg_credit,acc_credit,acc_amount_currency,acc_invoice_number ,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header  inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.acc_income_expense_header on acc_income_expense_header.ACC_REFERENCE_NO=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=acc_journal_details.acc_accountid where acc_journal_header.acc_transactiontype='Income' and acc_journal_details.acc_systemaccountid='Income' union all select acc_sg_debit,acc_debit,acc_amount_currency,acc_invoice_number ,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.acc_income_expense_header on acc_income_expense_header.ACC_REFERENCE_NO=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=acc_journal_details.acc_accountid where acc_journal_header.acc_transactiontype='Expense' and acc_journal_details.acc_systemaccountid='Expense' ) as TransactionAmount";

                    Item _get_transcationamount_data = myInnovator.applySQL(transcation_amountquery);

                    var _get_transcationamount_data_count = _get_transcationamount_data.getItemCount();

                    if (_get_transcationamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_transcationamount_data_count; m++)
                        {
                            var _get_transcationamount_data_result = _get_transcationamount_data.getItemByIndex(m);
                            var acc_sg_credit = _get_transcationamount_data_result.getProperty("acc_sg_credit");
                            var acc_credit = _get_transcationamount_data_result.getProperty("acc_credit");
                            var acc_amount_currency = _get_transcationamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_transcationamount_data_result.getProperty("pop_invoice_no");
                            var acc_accountdetail_name = _get_transcationamount_data_result.getProperty("acc_accountdetail_name");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_totalamount='" + acc_amount_currency + "' , acc_sg_totalamount='" + acc_sg_credit + "' ,acc_usd_totalamount='" + acc_credit + "' where acc_refno='" + pop_invoice_no + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End Transcation Amount*/


                    /*Start USD Amount*/

                    string usd_amountquery = "select * from ( select acc_sg_debit,acc_debit,acc_amount_currency,pop_invoice_no,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=pop_purchase_invoice.acc_account where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='Purchase' union all select acc_sg_credit,acc_credit,acc_amount_currency,sop_invoice_no,acc_AccountDetails.acc_accountdetail_name  from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.sop_sale_invoice on sop_sale_invoice.sop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=sop_sale_invoice.acc_account where acc_journal_header.acc_transactiontype='Sale' and acc_journal_details.acc_systemaccountid='Sale' union all select acc_sg_debit,acc_debit,acc_amount_currency,acc_invoice_number ,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.acc_income_expense_header on acc_income_expense_header.ACC_REFERENCE_NO=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=acc_journal_details.acc_accountid where acc_journal_header.acc_transactiontype='Expense' and acc_journal_details.acc_systemaccountid='Expense' union all select acc_sg_credit,ACC_CREDIT,acc_amount_currency,acc_invoice_number ,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.acc_income_expense_header on acc_income_expense_header.ACC_REFERENCE_NO=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=acc_journal_details.acc_accountid where acc_journal_header.acc_transactiontype='Income' and acc_journal_details.acc_systemaccountid='Income') As SubAmount";

                    Item _get_usdamount_data = myInnovator.applySQL(usd_amountquery);

                    var _get_usdamount_data_count = _get_usdamount_data.getItemCount();

                    if (_get_usdamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_usdamount_data_count; m++)
                        {
                            var _get_usdamount_data_result = _get_usdamount_data.getItemByIndex(m);
                            var acc_sg_debit = _get_usdamount_data_result.getProperty("acc_sg_debit");
                            var acc_debit = _get_usdamount_data_result.getProperty("acc_debit");
                            var acc_amount_currency = _get_usdamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_usdamount_data_result.getProperty("pop_invoice_no");
                            var acc_accountdetail_name = _get_usdamount_data_result.getProperty("acc_accountdetail_name");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_subamount='" + acc_amount_currency + "' , acc_sg_subamount='" + acc_sg_debit + "' ,acc_usd_subamount='" + acc_debit + "' where acc_refno='" + pop_invoice_no + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End USD Amount*/




                    /*Start SGD Amount*/

                    string sgd_amountquery = "select acc_sg_debit,acc_debit,acc_amount_currency,pop_invoice_no,acc_accountdetail_name from (select acc_sg_debit,acc_debit,acc_amount_currency,pop_invoice_no,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=pop_purchase_invoice.acc_account where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='GST Tax For Bill' union all select acc_sg_credit,acc_credit,acc_amount_currency,sop_invoice_no,acc_AccountDetails.acc_accountdetail_name from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.sop_sale_invoice on sop_sale_invoice.sop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.acc_AccountDetails on acc_AccountDetails.id=sop_sale_invoice.acc_account where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='GST Tax For Bill' ) as GSTAmount";

                    Item _get_sgdamount_data = myInnovator.applySQL(sgd_amountquery);

                    var _get_sgdamount_data_count = _get_sgdamount_data.getItemCount();

                    if (_get_sgdamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_sgdamount_data_count; m++)
                        {
                            var _get_sgdamount_data_result = _get_sgdamount_data.getItemByIndex(m);
                            var acc_sg_debit = _get_sgdamount_data_result.getProperty("acc_sg_debit");
                            var acc_debit = _get_sgdamount_data_result.getProperty("acc_debit");
                            var acc_amount_currency = _get_sgdamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_sgdamount_data_result.getProperty("pop_invoice_no");
                            var acc_accountdetail_name = _get_sgdamount_data_result.getProperty("acc_accountdetail_name");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_gstamount='" + acc_amount_currency + "' , acc_sg_gstamount='" + acc_sg_debit + "' ,acc_usd_gstamount='" + acc_debit + "' where acc_refno='" + pop_invoice_no + "' and acc_accountdetail_name='" + acc_accountdetail_name + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End USD Amount*/


                }
                else if (acc_vch_type == "PurchaseRegister")
                {
                    qurey = "select  acc_date,pop_invoice_remarks,acc_journal_no,pop_purchase_invoice.acc_account,innovator.ConvertToLocal(pop_purchase_invoice.pop_invoice_date,DEFAULT) as pop_invoice_date,pop_invoice_no,Vendor.name,sum(pop_purchase_invoice.pop_total_amount) as pop_total_amount,pop_purchase_invoice.pop_sub_amount,pop_purchase_invoice.pop_gst_amount,pop_purchase_invoice.pop_sg_total_amount,pop_purchase_invoice.pop_sg_sub_amount,pop_purchase_invoice.pop_sg_gst_amount,pop_purchase_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,pop_purchase_invoice.acc_tax_type from innovator.acc_journal_header inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO inner join innovator.ACC_CURRENCY on ACC_CURRENCY.id=pop_purchase_invoice.pop_currency inner join innovator.Vendor on Vendor.id=pop_purchase_invoice.pop_vendor inner join innovator.acc_AccountDetails on acc_AccountDetails.id=pop_purchase_invoice.acc_account inner join innovator.pop_purchase_allocation on pop_purchase_allocation.SOURCE_ID=pop_purchase_invoice.id where acc_journal_header.acc_transactiontype='Purchase'" + date_condition + " group by pop_invoice_no,acc_date,pop_invoice_remarks,acc_journal_no,pop_purchase_invoice.acc_account,pop_purchase_invoice.pop_invoice_date,pop_invoice_no,Vendor.name,pop_purchase_invoice.pop_sub_amount,pop_purchase_invoice.pop_gst_amount,pop_purchase_invoice.pop_sg_total_amount,pop_purchase_invoice.pop_sg_sub_amount,pop_purchase_invoice.pop_sg_gst_amount,pop_purchase_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,pop_purchase_invoice.acc_tax_type  order by name,Convert(Date,acc_date,111) ,pop_invoice_no ASC";
                    Item _get_data = myInnovator.applySQL(qurey);

                    var _get_data_count = _get_data.getItemCount();

                    if (_get_data_count > 0)
                    {
                        for (int i = 0; i < _get_data_count; i++)
                        {
                            var j = i + 1;
                            var _get_data_result = _get_data.getItemByIndex(i);
                            var acc_date = _get_data_result.getProperty("acc_date");
                            DateTime dt_acc_date = DateTime.Parse(acc_date);

                            dt_acc_date = new DateTimeOffset(dt_acc_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                            var get_last_date = dt_acc_date.ToString("yyyy-MM-ddTHH:mm:ss");
                            var acc_currency_id = "374D7C8DC875411A9A3BD0FC5A8BC066";

                            var query = "select acc_currency.id,acc_currency.ACC_OPERATOR,acc_currencycode,acc_currency_detail.acc_monthly_rate,acc_currency_detail.acc_date" + " from innovator.acc_currency inner join innovator.acc_currency_detail" + " on  acc_currency.id=acc_currency_detail.source_id " + " where acc_currency.id='" + acc_currency_id + "' " + " and DATEPART(m, acc_currency_detail.acc_date) = DATEPART(m, DATEADD(m, -1, '" + get_last_date + "')) AND DATEPART(yyyy, acc_currency_detail.acc_date) = DATEPART(yyyy, DATEADD(m, -1, '" + get_last_date + "'))";
                            Item result_currency = myInnovator.applySQL(query);
                            var lastMonthRate = result_currency.getProperty("acc_monthly_rate", "");
                            var local_acc_date = dt_acc_date.ToString("yyyy-MM-dd");
                            var name = _get_data_result.getProperty("name");

                            var pop_invoice_date = _get_data_result.getProperty("pop_invoice_date");
                            DateTime dt_pop_invoice_date = DateTime.Parse(pop_invoice_date);
                            dt_pop_invoice_date = new DateTimeOffset(dt_pop_invoice_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                            var local_pop_invoice_date = dt_pop_invoice_date.ToString("yyyy-MM-dd");
                            var acc_refno = _get_data_result.getProperty("pop_invoice_no");
                            var pop_total_amount = _get_data_result.getProperty("pop_total_amount");
                            var pop_currency_rate = _get_data_result.getProperty("pop_currency_rate");
                            var acc_currencycode = _get_data_result.getProperty("acc_currencycode");
                            var acc_accountdetail_name = _get_data_result.getProperty("acc_accountdetail_name");
                            var pop_sub_amount = _get_data_result.getProperty("pop_sub_amount");
                            var pop_gst_amount = _get_data_result.getProperty("pop_gst_amount");
                            var pop_sg_total_amount = _get_data_result.getProperty("pop_sg_total_amount");
                            var pop_sg_sub_amount = _get_data_result.getProperty("pop_sg_sub_amount");
                            var pop_sg_gst_amount = _get_data_result.getProperty("pop_sg_gst_amount");
                            var acc_tax_type = _get_data_result.getProperty("acc_tax_type");
                            var pop_invoice_remarks = _get_data_result.getProperty("pop_invoice_remarks");
                            var acc_journal_no = _get_data_result.getProperty("acc_journal_no");

                            Item acc_journal_register = myInnovator.newItem("acc_journal_register", "add");
                            acc_journal_register.setProperty("acc_journalregister_date", local_acc_date);
                            acc_journal_register.setProperty("sop_invoice_date", local_pop_invoice_date);

                            acc_journal_register.setProperty("acc_accountdetail_name", acc_accountdetail_name);
                            acc_journal_register.setProperty("acc_rate", pop_currency_rate);
                            acc_journal_register.setProperty("acc_currencycode", acc_currencycode);
                            acc_journal_register.setProperty("acc_amount_currency", pop_total_amount);

                            acc_journal_register.setProperty("erp_company", erp_company);
                            acc_journal_register.setProperty("erp_com_name", erp_com_name);
                            acc_journal_register.setProperty("acc_refno", acc_refno);
                            acc_journal_register.setProperty("pop_sub_amount", pop_sub_amount);
                            acc_journal_register.setProperty("pop_gst_amount", pop_gst_amount);
                            acc_journal_register.setProperty("acc_from_date", acc_from_date);
                            acc_journal_register.setProperty("acc_to_date", acc_to_date);
                            acc_journal_register.setProperty("acc_journal_no", acc_journal_no);
                            acc_journal_register.setProperty("pop_vendor_name", name);
                            acc_journal_register.setProperty("pop_sg_total_amount", pop_sg_total_amount);
                            acc_journal_register.setProperty("acc_vch_type", "Purchase");
                            acc_journal_register.setProperty("pop_sg_sub_amount", pop_sg_sub_amount);
                            acc_journal_register.setProperty("pop_sg_gst_amount", pop_sg_gst_amount);
                            acc_journal_register.setProperty("acc_tax_type", acc_tax_type);
                            acc_journal_register.setProperty("acc_lastmonthrate", lastMonthRate);
                            acc_journal_register.setProperty("pop_invoice_remarks", pop_invoice_remarks);
                            acc_journal_register.setProperty("acc_report_currency_filter", acc_report_currency);
                            acc_journal_register = acc_journal_register.apply();
                            int icount = acc_journal_register.getItemCount();
                            if (acc_journal_register.isError())
                            {
                                return myInnovator.newError("Error While Adding Purchase Register report.");
                            }
                        }
                    }

                    /* Start Greater Than One allocation*/

                    string queryallocation = "select sum(pop_purchase_allocation.acc_amount),acc_department_so_no,pop_invoice_no,acc_department_so_name from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id group by acc_department_so_no,pop_invoice_no,acc_department_so_name";

                    Item _get_allocation_data = myInnovator.applySQL(queryallocation);

                    var _get_allocation_data_count = _get_allocation_data.getItemCount();

                    if (_get_allocation_data_count > 0)
                    {
                        for (int l = 0; l < _get_allocation_data_count; l++)
                        {
                            var __get_allocation_data_result = _get_allocation_data.getItemByIndex(l);
                            var pop_invoice_no_allocation = __get_allocation_data_result.getProperty("pop_invoice_no");
                            var acc_department_so_no_allocation = __get_allocation_data_result.getProperty("acc_department_so_no");
                            var acc_department_so_no = __get_allocation_data_result.getProperty("acc_department_so_no");
                            var acc_department_so_name = __get_allocation_data_result.getProperty("acc_department_so_name");

                            if (acc_department_so_no_allocation == "D10")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D10=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "'),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D15")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D15=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "'),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D20")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D20=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "'),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "'where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D25")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D25=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "'),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D28")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D28=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "' ),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D30")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D30=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "'),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D35")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D35=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "' ),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }
                            else if (acc_department_so_no_allocation == "D40")
                            {
                                myInnovator.applySQL(" update innovator.acc_journal_register set ACC_D40=(select sum(pop_purchase_allocation.acc_amount) acc_amount from innovator.POP_PURCHASE_INVOICE inner join innovator.pop_purchase_allocation on pop_purchase_allocation.source_id= POP_PURCHASE_INVOICE.id where pop_invoice_no='" + pop_invoice_no_allocation + "' and acc_department_so_no='" + acc_department_so_no_allocation + "'),acc_department_so_name='" + acc_department_so_name + "',acc_department_so_no='" + acc_department_so_no + "' where acc_refno='" + pop_invoice_no_allocation + "'");
                            }

                        }
                    }
                    /* End Greater Than One allocation*/


                    /*Start Invoice Divided By Count*/

                    Item _get_journal_data = myInnovator.applySQL(queryjournal);
                    var _get_journal_data_count = _get_journal_data.getItemCount();

                    if (_get_journal_data_count > 0)
                    {
                        for (int m = 0; m < _get_journal_data_count; m++)
                        {
                            var _get_journal_data_result = _get_journal_data.getItemByIndex(m);
                            var acc_refno_journal = _get_journal_data_result.getProperty("acc_refno");
                            string journal_divide = "update innovator.acc_journal_register set ACC_AMOUNT_CURRENCY=ACC_AMOUNT_CURRENCY/(select Count(pop_purchase_allocation.id) as number from innovator.pop_purchase_allocation inner join innovator.POP_PURCHASE_INVOICE on POP_PURCHASE_INVOICE.id=pop_purchase_allocation.SOURCE_ID where pop_invoice_no='" + acc_refno_journal + "') where acc_refno='" + acc_refno_journal + "'";
                            myInnovator.applySQL(journal_divide);
                        }
                    }

                    /*End Invoice Divided By Count*/

                    /*Start Transcation Amount*/

                    string transcation_amountquery = "select acc_sg_credit,acc_credit,acc_amount_currency,pop_invoice_no from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='Account Payable'";

                    Item _get_transcationamount_data = myInnovator.applySQL(transcation_amountquery);

                    var _get_transcationamount_data_count = _get_transcationamount_data.getItemCount();

                    if (_get_transcationamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_transcationamount_data_count; m++)
                        {
                            var _get_transcationamount_data_result = _get_transcationamount_data.getItemByIndex(m);
                            var acc_sg_credit = _get_transcationamount_data_result.getProperty("acc_sg_credit");
                            var acc_credit = _get_transcationamount_data_result.getProperty("acc_credit");
                            var acc_amount_currency = _get_transcationamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_transcationamount_data_result.getProperty("pop_invoice_no");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_totalamount='" + acc_amount_currency + "' , acc_sg_totalamount='" + acc_sg_credit + "' ,acc_usd_totalamount='" + acc_credit + "' where acc_refno='" + pop_invoice_no + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End Transcation Amount*/

                    /*Start USD Amount*/

                    string usd_amountquery = "select acc_sg_debit,acc_debit,acc_amount_currency,pop_invoice_no from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='Purchase'";

                    Item _get_usdamount_data = myInnovator.applySQL(usd_amountquery);

                    var _get_usdamount_data_count = _get_usdamount_data.getItemCount();

                    if (_get_usdamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_usdamount_data_count; m++)
                        {
                            var _get_usdamount_data_result = _get_usdamount_data.getItemByIndex(m);
                            var acc_sg_debit = _get_usdamount_data_result.getProperty("acc_sg_debit");
                            var acc_debit = _get_usdamount_data_result.getProperty("acc_debit");
                            var acc_amount_currency = _get_usdamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_usdamount_data_result.getProperty("pop_invoice_no");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_subamount='" + acc_amount_currency + "' , acc_sg_subamount='" + acc_sg_debit + "' ,acc_usd_subamount='" + acc_debit + "' where acc_refno='" + pop_invoice_no + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End USD Amount*/

                    /*Start SGD Amount*/

                    string sgd_amountquery = " select acc_sg_debit,acc_debit,acc_amount_currency,pop_invoice_no from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.pop_purchase_invoice on pop_purchase_invoice.pop_invoice_no=acc_journal_header.ACC_REFNO where acc_journal_header.acc_transactiontype='Purchase' and acc_journal_details.acc_systemaccountid='GST Tax For Bill'";
                    Item _get_sgdamount_data = myInnovator.applySQL(sgd_amountquery);
                    var _get_sgdamount_data_count = _get_sgdamount_data.getItemCount();

                    if (_get_sgdamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_sgdamount_data_count; m++)
                        {
                            var _get_sgdamount_data_result = _get_sgdamount_data.getItemByIndex(m);
                            var acc_sg_debit = _get_sgdamount_data_result.getProperty("acc_sg_debit");
                            var acc_debit = _get_sgdamount_data_result.getProperty("acc_debit");
                            var acc_amount_currency = _get_sgdamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_sgdamount_data_result.getProperty("pop_invoice_no");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_gstamount='" + acc_amount_currency + "' , acc_sg_gstamount='" + acc_sg_debit + "' ,acc_usd_gstamount='" + acc_debit + "' where acc_refno='" + pop_invoice_no + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End USD Amount*/

                }
                else
                {
                    qurey = "select acc_journal_header.acc_date,sop_sale_invoice.classification,acc_journal_no,sum(sop_sale_invoice.pop_total_amount) as pop_total_amount,CUSTOMER.name,sop_sale_invoice.sop_invoice_no,innovator.ConvertToLocal(sop_sale_invoice.sop_invoice_date,DEFAULT) as sop_invoice_date,innovator.ConvertToLocal(sop_sale_invoice.sop_due_date,DEFAULT) as sop_due_date,sop_sale_invoice.sop_payment_term,sop_sale_invoice.pop_sub_amount,sop_sale_invoice.pop_gst_amount,sop_sale_invoice.pop_sg_total_amount,sop_sale_invoice.pop_sg_sub_amount,sop_sale_invoice.pop_sg_gst_amount,sop_sale_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,sop_sale_invoice.acc_tax_type from innovator.acc_journal_header inner join innovator.sop_sale_invoice on sop_sale_invoice.id=acc_journal_header.acc_sop_voucher_reference inner join innovator.ACC_CURRENCY on ACC_CURRENCY.id=sop_sale_invoice.pop_currency left join innovator.CUSTOMER on CUSTOMER.id=sop_sale_invoice.sop_customer inner join innovator.acc_AccountDetails on acc_AccountDetails.id=sop_sale_invoice.acc_account inner join innovator.sop_sale_allocation on sop_sale_allocation.SOURCE_ID=sop_sale_invoice.id where acc_journal_header.acc_transactiontype='Sale'  " + date_condition + " group by sop_invoice_no,acc_date,acc_journal_no,sop_sale_invoice.acc_account,sop_sale_invoice.sop_invoice_date,Customer.name,sop_sale_invoice.pop_sub_amount,sop_sale_invoice.pop_gst_amount,sop_sale_invoice.pop_sg_total_amount,sop_sale_invoice.pop_sg_sub_amount,sop_sale_invoice.pop_sg_gst_amount,sop_sale_invoice.pop_currency_rate,ACC_CURRENCY.acc_currencycode,acc_AccountDetails.acc_accountdetail_name,sop_sale_invoice.acc_tax_type,sop_sale_invoice.classification,SOP_DUE_DATE,SOP_PAYMENT_TERM order by name,Convert(Date,acc_date,111) ,sop_invoice_no ASC";
                    Item _get_data = myInnovator.applySQL(qurey);
                    var _get_data_count = _get_data.getItemCount();

                    if (_get_data_count > 0)
                    {
                        for (int i = 0; i < _get_data_count; i++)
                        {
                            var j = i + 1;
                            var _get_data_result = _get_data.getItemByIndex(i);
                            var acc_date = _get_data_result.getProperty("acc_date");
                            DateTime dt_acc_date = DateTime.Parse(acc_date);

                            dt_acc_date = new DateTimeOffset(dt_acc_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                            var local_acc_date = dt_acc_date.ToString("yyyy-MM-dd");

                            var sop_invoice_date = _get_data_result.getProperty("sop_invoice_date");
                            DateTime dt_acc_invoice_date = DateTime.Parse(sop_invoice_date);

                            dt_acc_invoice_date = new DateTimeOffset(dt_acc_invoice_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                            var local_acc_invoice_date = dt_acc_invoice_date.ToString("yyyy-MM-dd");

                            var name = _get_data_result.getProperty("name");
                            var sop_invoice_no = _get_data_result.getProperty("sop_invoice_no");
                            var pop_total_amount = _get_data_result.getProperty("pop_total_amount");
                            var sop_payment_term = _get_data_result.getProperty("sop_payment_term");
                            var acc_journal_no = _get_data_result.getProperty("acc_journal_no");
                            var classification = _get_data_result.getProperty("classification");

                            Item acc_journal_register = myInnovator.newItem("acc_journal_register", "add");
                            acc_journal_register.setProperty("acc_journalregister_date", local_acc_date);
                            acc_journal_register.setProperty("pop_vendor_name", name);
                            acc_journal_register.setProperty("acc_refno", sop_invoice_no);
                            acc_journal_register.setProperty("acc_journal_no", acc_journal_no);
                            acc_journal_register.setProperty("sop_payment_term", sop_payment_term);
                            acc_journal_register.setProperty("sop_invoice_date", local_acc_invoice_date);
                            acc_journal_register.setProperty("erp_company", erp_company);
                            acc_journal_register.setProperty("erp_com_name", erp_com_name);
                            acc_journal_register.setProperty("acc_from_date", acc_from_date);
                            acc_journal_register.setProperty("acc_to_date", acc_to_date);
                            acc_journal_register.setProperty("acc_vch_type", "Sale");
                            acc_journal_register.setProperty("acc_amount_currency", pop_total_amount);
                            if (classification == "EQUIPMENT")
                            {
                                acc_journal_register.setProperty("acc_journal_classification", "Sales");
                                acc_journal_register.setProperty("acc_department", "D25");
                            }
                            else
                            {
                                acc_journal_register.setProperty("acc_journal_classification", "Service Income");
                                acc_journal_register.setProperty("acc_department", "D40");
                            }
                            acc_journal_register.setProperty("acc_report_currency_filter", acc_report_currency);
                            acc_journal_register = acc_journal_register.apply();
                            int icount = acc_journal_register.getItemCount();
                            if (acc_journal_register.isError())
                            {
                                return myInnovator.newError("Error While Adding Sale Register report.");
                            }
                        }
                    }
                    /*Start Transcation Amount*/

                    string transcation_amountquery = "select acc_sg_debit,acc_debit,acc_amount_currency,sop_invoice_no from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.sop_sale_invoice on sop_sale_invoice.sop_invoice_no=acc_journal_header.ACC_REFNO where acc_journal_header.acc_transactiontype='Sale' and acc_journal_details.acc_systemaccountid='Account Receivable'";

                    Item _get_transcationamount_data = myInnovator.applySQL(transcation_amountquery);

                    var _get_transcationamount_data_count = _get_transcationamount_data.getItemCount();

                    if (_get_transcationamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_transcationamount_data_count; m++)
                        {
                            var _get_transcationamount_data_result = _get_transcationamount_data.getItemByIndex(m);
                            var acc_sg_credit = _get_transcationamount_data_result.getProperty("acc_sg_debit");
                            var acc_credit = _get_transcationamount_data_result.getProperty("acc_debit");
                            var acc_amount_currency = _get_transcationamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_transcationamount_data_result.getProperty("sop_invoice_no");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_totalamount='" + acc_amount_currency + "' , acc_sg_totalamount='" + acc_sg_credit + "' ,acc_usd_totalamount='" + acc_credit + "' where acc_refno='" + pop_invoice_no + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End Transcation Amount*/

                    /*Start Transcation Amount*/

                    string transcation_subquery = "select acc_sg_credit,acc_credit,acc_amount_currency,sop_invoice_no from  innovator.acc_journal_header inner join innovator.acc_journal_details on acc_journal_details.source_id=acc_journal_header.id inner join innovator.sop_sale_invoice on sop_sale_invoice.sop_invoice_no=acc_journal_header.ACC_REFNO where acc_journal_header.acc_transactiontype='Sale' and acc_journal_details.acc_systemaccountid='Sale'";

                    Item _get_transcationsubamount_data = myInnovator.applySQL(transcation_subquery);

                    var _get_transcationsubamount_data_count = _get_transcationsubamount_data.getItemCount();

                    if (_get_transcationamount_data_count > 0)
                    {
                        for (int m = 0; m < _get_transcationsubamount_data_count; m++)
                        {
                            var _get_transcationsubamount_data_result = _get_transcationsubamount_data.getItemByIndex(m);
                            var acc_sg_credit = _get_transcationsubamount_data_result.getProperty("acc_sg_credit");
                            var acc_credit = _get_transcationsubamount_data_result.getProperty("acc_credit");
                            var acc_amount_currency = _get_transcationsubamount_data_result.getProperty("acc_amount_currency");
                            var pop_invoice_no = _get_transcationsubamount_data_result.getProperty("sop_invoice_no");

                            string transcation_amount_insert = "update innovator.acc_journal_register set acc_transaction_subamount='" + acc_amount_currency + "' , acc_sg_subamount='" + acc_sg_credit + "' ,acc_usd_subamount='" + acc_credit + "' where acc_refno='" + pop_invoice_no + "'";
                            myInnovator.applySQL(transcation_amount_insert);
                        }
                    }

                    /*End Transcation Amount*/
                }
                if (acc_vch_type == "JournalRegister" || acc_vch_type == "PurchaseRegister")
                {
                    /*Start USD/SGD multiply lastmonthreate*/

                    Item _get_update_data = myInnovator.applySQL(queryjournal);

                    var _get__get_update_data_count = _get_update_data.getItemCount();

                    if (_get__get_update_data_count > 0)
                    {
                        for (int m = 0; m < _get__get_update_data_count; m++)
                        {
                            var _get_update_data_result = _get_update_data.getItemByIndex(m);
                            var id = _get_update_data_result.getProperty("id");
                            var acc_journaltype = _get_update_data_result.getProperty("acc_journaltype");
                            var acc_lastmonthrate = _get_update_data_result.getProperty("acc_lastmonthrate");
                            var acc_usd_totalamount = _get_update_data_result.getProperty("acc_usd_totalamount");
                            if (acc_usd_totalamount == null)
                            {
                                acc_usd_totalamount = "0.00";
                            }
                            var acc_report_currency_filter = _get_update_data_result.getProperty("acc_report_currency_filter");

                            var acc_currencycode = _get_update_data_result.getProperty("acc_currencycode");
                            string[] allocation_amount = new string[8] { "", "", "", "", "", "", "", "" };
                            var ACC_D10 = _get_update_data_result.getProperty("acc_d10");
                            var ACC_D15 = _get_update_data_result.getProperty("acc_d15");
                            var ACC_D20 = _get_update_data_result.getProperty("acc_d20");
                            var ACC_D25 = _get_update_data_result.getProperty("acc_d25");
                            var ACC_D28 = _get_update_data_result.getProperty("acc_d28");
                            var ACC_D30 = _get_update_data_result.getProperty("acc_d30");
                            var ACC_D35 = _get_update_data_result.getProperty("acc_d35");
                            var ACC_D40 = _get_update_data_result.getProperty("acc_d40");
                            var acc_rate = _get_update_data_result.getProperty("acc_rate");
                            allocation_amount[0] = ACC_D10;
                            allocation_amount[1] = ACC_D15;
                            allocation_amount[2] = ACC_D20;
                            allocation_amount[3] = ACC_D25;
                            allocation_amount[4] = ACC_D28;
                            allocation_amount[5] = ACC_D30;
                            allocation_amount[6] = ACC_D35;
                            allocation_amount[7] = ACC_D40;

                            if (acc_report_currency_filter == "SGD")
                            {
                                if (acc_journaltype == "Income" || acc_journaltype == "Expnese")
                                {
                                    acc_usd_totalamount = (Convert.ToDecimal(acc_usd_totalamount) * Convert.ToDecimal(acc_lastmonthrate)).ToString();
                                }
                                if (acc_currencycode != "SGD")
                                {
                                    if (ACC_D10 != null)
                                    {
                                        allocation_amount[0] = (Convert.ToDecimal(ACC_D10) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString();
                                    }
                                    if (ACC_D15 != null)
                                    {
                                        allocation_amount[1] = (Convert.ToDecimal(ACC_D15) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                    if (ACC_D20 != null)
                                    {
                                        allocation_amount[2] = (Convert.ToDecimal(ACC_D20) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                    if (ACC_D25 != null)
                                    {
                                        allocation_amount[3] = (Convert.ToDecimal(ACC_D25) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                    if (ACC_D28 != null)
                                    {
                                        allocation_amount[4] = (Convert.ToDecimal(ACC_D28) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                    if (ACC_D30 != null)
                                    {
                                        allocation_amount[5] = (Convert.ToDecimal(ACC_D30) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                    if (ACC_D35 != null)
                                    {
                                        allocation_amount[6] = (Convert.ToDecimal(ACC_D35) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                    if (ACC_D40 != null)
                                    {
                                        allocation_amount[7] = (Convert.ToDecimal(ACC_D40) / Convert.ToDecimal(acc_rate) * Convert.ToDecimal(acc_lastmonthrate)).ToString(); ;
                                    }
                                }
                            }
                            else
                            {
                                if (ACC_D10 != null)
                                {
                                    allocation_amount[0] = (Convert.ToDecimal(ACC_D10) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D15 != null)
                                {
                                    allocation_amount[1] = (Convert.ToDecimal(ACC_D15) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D20 != null)
                                {
                                    allocation_amount[2] = (Convert.ToDecimal(ACC_D20) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D25 != null)
                                {
                                    allocation_amount[3] = (Convert.ToDecimal(ACC_D25) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D28 != null)
                                {
                                    allocation_amount[4] = (Convert.ToDecimal(ACC_D28) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D30 != null)
                                {
                                    allocation_amount[5] = (Convert.ToDecimal(ACC_D30) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D35 != null)
                                {
                                    allocation_amount[6] = (Convert.ToDecimal(ACC_D35) / Convert.ToDecimal(acc_rate)).ToString(); ;
                                }
                                if (ACC_D40 != null)
                                {
                                    allocation_amount[7] = (Convert.ToDecimal(ACC_D40) / Convert.ToDecimal(acc_rate)).ToString();
                                }
                            }
                            if (allocation_amount[0] == null)
                            {
                                allocation_amount[0] = "0.00";
                            }
                            if (allocation_amount[1] == null)
                            {
                                allocation_amount[1] = "0.00";
                            }
                            if (allocation_amount[2] == null)
                            {
                                allocation_amount[2] = "0.00";
                            }
                            if (allocation_amount[3] == null)
                            {
                                allocation_amount[3] = "0.00";
                            }
                            if (allocation_amount[4] == null)
                            {
                                allocation_amount[4] = "0.00";
                            }
                            if (allocation_amount[5] == null)
                            {
                                allocation_amount[5] = "0.00";
                            }
                            if (allocation_amount[6] == null)
                            {
                                allocation_amount[6] = "0.00";
                            }
                            if (allocation_amount[7] == null)
                            {
                                allocation_amount[7] = "0.00";
                            }
                            string queryusdsgd = "update innovator.acc_journal_register set acc_usd_totalamount=" + acc_usd_totalamount + ",ACC_D10=" + allocation_amount[0] + ",ACC_D15=" + allocation_amount[1] + ",ACC_D20=" + allocation_amount[2] + ",ACC_D25=" + allocation_amount[3] + ",ACC_D28=" + allocation_amount[4] + ",ACC_D30=" + allocation_amount[5] + ",ACC_D35=" + allocation_amount[6] + ",ACC_D40=" + allocation_amount[7] + " where id='" + id + "'";
                            myInnovator.applySQL(queryusdsgd);

                            allocation_amount = new string[8] { "", "", "", "", "", "", "", "" };
                        }
                    }
                    /*End USD/SGD multiply lastmonthreate*/
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_journal_register_report</name>
 </Item>
</AML>